-----------------------------[-----------------------------[ Requirements ]-----------------------------]-----------------------------
require 'simple-slider'
-----------------------------[-----------------------------[ Localising / Variables ]-----------------------------]-----------------------------
local Selector, Selector2, Max_options
local menu_font, menu_fontS
local A1, A2, A3, A4, A5, A6
local Menustate
local WidthS, HeightS
local Snake
local screen_width, screen_height
local Left, Right
local RESnum, Res
local canvas
local PW, MW, PH, MH
local WG, HG

RESnum = 3
Res = "Windowed"
screen_width, screen_height = love.window.getDesktopDimensions()
canvas = love.graphics.newCanvas(love.graphics.getHeight(), love.graphics.getWidth())

-------------------{{{{{{{{ notes }}}}}}}}-------------------
--[[

--
1 in gridXCount/gridYCount is equal to 8 squares of the background
so if gridYCount and gridXCount is equal to 10 then there would 6400 squares in total across the screen
that means alot of fucking math - Great T_T!
--

-- 11.5 is equal to love.graphics.getWidth()/X squares found in screen

--]]


-----------------------------[-----------------------------[ Outside Variables ]-----------------------------]-----------------------------
local Menu = {Active = 1, Select = "Exit", gridXCount = 40, gridYCount = 40}
-----------------------------[-----------------------------[ Main ]-----------------------------]-----------------------------

print(love.graphics.getHeight(), love.graphics.getWidth())
love.graphics.print(screen_width, screen_height)

function Menu.load()
    love.graphics.setCanvas()

    love.graphics.setColor(255,255,255)

    --love.window.setMode(screen_width/2, screen_height/2) -- can't do this since it will just resize window when exiting

    love.mouse.setVisible(false)
    menu_font = love.graphics.newFont('PixelFJVerdana12pt_0.ttf', 20)-- + love.graphics.getWidth()/55 --20
    menu_fontS = love.graphics.newFont('PixelFJVerdana12pt_0.ttf', 14)-- + love.graphics.getWidth()/84 --14
    love.graphics.setFont(menu_font)
    Menustate = "Menu"

    Left = {}
    Left.text = love.graphics.newText(menu_font, "<")
    Left.x = 360
    Left.y = 120

    Right = {}
    Right.text = love.graphics.newText(menu_font, ">")
    Right.x = 520
    Right.y = 120



    PW = {}
    PW.text = love.graphics.newText(menu_font, "+")
    PW.x = 80
    PW.y = 55

    MW = {}
    MW.text = love.graphics.newText(menu_font, "-")
    MW.x = 160
    MW.y = 55

    PH = {}
    PH.text = love.graphics.newText(menu_font, "+")
    PH.x = 80
    PH.y = 155

    MH = {}
    MH.text = love.graphics.newText(menu_font, "-")
    MH.x = 160
    MH.y = 155

    WG = {}
    HG = {}

    WG.val = Menu.gridXCount
    HG.val = Menu.gridYCount

    Snake = {x = 100,
             y = 500,
             w = 20,
             h = 20,
             direction = "right",
             speed = 200,
             cellSize = 15,
             Alive = true,
             R = 0,
             G = 255,
             B = 0,
             Segments = {
             {x = 3, y = 1},
             {x = 2, y = 1},
             {x = 1, y = 1}
             }
             }

    Selector = 1
    Selector2 = 1

    A1 = 40
    A2 = 20
    A3 = 20
    A4 = 20
    A5 = 40
    A6 = 20


    WidthS = newSlider(
            170,
            80,
            300,
            Menu.gridXCount*15 * Snake.cellSize,
            screen_width/2,
            screen_width,
            function (v)
                Menu.gridXCount = math.floor(v) / Snake.cellSize
                math.floor(Menu.gridXCount)
            end
            )

    HeightS = newSlider(
            170,
            160,
            300,
            Menu.gridYCount * Snake.cellSize,
            screen_height/2,
            screen_height,
            function (v)
                Menu.gridYCount = math.floor(v) / Snake.cellSize
                math.floor(Menu.gridYCount)
            end
            )
end

function Menu.update()
    WidthS:update()
    HeightS:update()
end


function love.mousepressed(x, y, button, istouch)
    x = love.mouse.getX()
    y = love.mouse.getY()

    if x >= Left.x and x <= Left.x + Left.text:getWidth() and y >= Left.y and y <= Left.y + Left.text:getHeight() then
        RESnum = RESnum + 1
    end

    if x >= Right.x and x <= Right.x + Right.text:getWidth() and y >= Right.y and y <= Right.y + Right.text:getHeight() then
        RESnum = RESnum - 1
    end

    if RESnum == 4 then
        RESnum = 1
    end

    if RESnum == 0 then
        RESnum = 3
    end

    if RESnum == 1 then
        Res = "Custom"
    end
    if RESnum == 2 then
        Res = "Fullscreen"
    end
    if RESnum == 3 then
        Res = "Windowed"
    end


    if x >= PW.x and x <= PW.x + PW.text:getWidth() and y >= PW.y and y <= PW.y + PW.text:getHeight() then
        WG.val = WG.val + 1
        print("W = " .. tostring(Menu.gridXCount))
    end

    if x >= MW.x and x <= MW.x + MW.text:getWidth() and y >= MW.y and y <= MW.y + MW.text:getHeight() then
        WG.val = WG.val - 1
        print("W = " .. tostring(Menu.gridXCount))
    end

    if x >= PH.x and x <= PH.x + PH.text:getWidth() and y >= PH.y and y <= PH.y + PH.text:getHeight() then
        HG.val = HG.val + 1
        print("H = " .. tostring(Menu.gridYCount))
    end

    if x >= MH.x and x <= MH.x + MH.text:getWidth() and y >= MH.y and y <= MH.y + MH.text:getHeight() then
        HG.val = HG.val - 1
        print("H = " .. tostring(Menu.gridYCount))
    end
end


function Menu.keypressed(key)
    if Menustate ~= "settings" then

    Max_options = 3

    if key == 'down' or key == 's' then
        Selector = Selector + 1
        if Selector > Max_options then Selector = 1 end

    elseif key == 'up' or key == 'w' then
        Selector = Selector - 1
        if Selector < 1 then Selector = Max_options end

    elseif key == 'return' then
        if Menustate == "Menu" then

        if Selector == 1 then
            Menu.Active = 0
        end

        if Selector == 2 then
            Menustate = "settings"
            love.mouse.setVisible(true)
            love.graphics.clear()
        end

        if Selector == 3 then
            love.event.quit()
        end

        end
    end

    if Selector == 1 then
        A1 = 40
    else
        A1 = 20
    end

    if Selector == 2 then
        A2 = 40
    else
        A2 = 20
    end

    if Selector == 3 then
        A3 = 40
    else
        A3 = 20
    end

    else

    Max_options = 2

    if key == 'down' or key == 's' then
        Selector2 = Selector2 + 1
        if Selector2 > Max_options then Selector2 = 1 end

    elseif key == 'up' or key == 'w' then
        Selector2 = Selector2 - 1
        if Selector2 < 1 then Selector2 = Max_options end

    elseif key == 'return' then
        if Selector2 == 1 then
            love.graphics.clear()
            love.graphics.setCanvas()
            love.window.setMode(Menu.gridXCount, Menu.gridYCount)
            --Menu.load()
        end

        if Selector2 == 2 then
            Menu.load()
        end
    end

    if Selector2 == 1 then
        A5 = 40
    else
        A5 = 20
    end

    if Selector2 == 2 then
        A6 = 40
    else
        A6 = 20
    end

    end

end

function Menu.draw()
    if Menu.Active == 1 then
        if Menustate == "settings" then
            love.graphics.setBackgroundColor(0, 0, 0)

            love.graphics.setLineWidth(4)
            love.graphics.setColor(254, 67, 101)

            love.graphics.setColor(255, 0, 0)
            love.graphics.rectangle("line", 400, 55, screen_width/ Snake.cellSize + 10, screen_height/ Snake.cellSize + 10)
            love.graphics.setColor(255, 255, 255)

            love.graphics.setFont(menu_fontS)

            print(Menu.gridXCount, Menu.gridYCount)

            if RESnum == 1 then
                Menu.gridXCount = WG.val
                Menu.gridYCount = HG.val

                love.graphics.setFont(menu_font)
                if Menu.gridXCount == screen_width/ Snake.cellSize and
                    Menu.gridYCount == screen_height/ Snake.cellSize  or
                    Menu.gridYCount == 0 or
                    Menu.gridXCount == 0 then

                    love.graphics.printf("Fullscreen", 360, 10, 400)
                else
                    love.graphics.printf(tostring(math.floor(Menu.gridXCount) ..'X'..
                        math.floor(Menu.gridYCount)) , 375, 10, 400)
                end

            love.graphics.setColor(255, 255, 255)
            love.graphics.rectangle("line", 405, 60, Menu.gridXCount, Menu.gridYCount)

            love.graphics.setFont(menu_fontS)
            love.graphics.printf(tostring(Res), 400, 127, 400)
            love.graphics.setFont(menu_font)

            elseif RESnum == 2 then
                love.graphics.setFont(menu_font)
                love.graphics.printf("Fullscreen", 360, 10, 400)
                love.graphics.setFont(menu_fontS)
                love.graphics.printf(tostring(Res), 390, 127, 400)
                love.graphics.setFont(menu_font)

                love.graphics.setColor(255, 255, 255)
                love.graphics.rectangle("line", 405, 60, screen_width/15, screen_height/15)
            elseif RESnum == 3 then
                love.graphics.setFont(menu_font)
                love.graphics.printf("Windowed", 360, 10, 400)
                love.graphics.setFont(menu_fontS)
                love.graphics.printf(tostring(Res), 385, 127, 400)

                Menu.gridXCount = screen_width/30
                Menu.gridYCount = screen_height/30

                love.graphics.setColor(255, 255, 255)
                love.graphics.rectangle("line", 405, 60, screen_width/15/2, screen_height/15/2)
            end

            if Res == "Windowed" then
                Menu.gridXCount = screen_width/15/2
                Menu.gridYCount = screen_height/15/2

                love.graphics.setFont(menu_font)
                love.graphics.printf(tostring(math.floor(Menu.gridXCount * 15)), 10, 50, 400)
                love.graphics.printf(tostring(math.floor(Menu.gridYCount * 15)), 10, 150, 400)
            elseif Res == "Fullscreen" then
                Menu.gridXCount = screen_width/15
                Menu.gridYCount = screen_height/15

                love.graphics.setFont(menu_font)
                love.graphics.printf(tostring(math.floor(screen_height)), 10, 50, 400)
                love.graphics.printf(tostring(math.floor(screen_width)), 10, 150, 400)
            elseif Res == "Custom" then
                love.graphics.draw(PW.text, PW.x, PW.y)
                love.graphics.draw(MW.text, MW.x, MW.y)
                love.graphics.draw(PH.text, PH.x, PH.y)
                love.graphics.draw(MH.text, MH.x, MH.y)
            end

            love.graphics.setFont(menu_font)

            love.graphics.printf("Screen Width", 10, 10, 400)
            love.graphics.printf("Screen Height", 10, 100, 400)

            love.graphics.draw(Right.text, Right.x, Right.y)
            love.graphics.draw(Left.text, Left.x, Left.y)

            love.graphics.printf("Apply and Exit", A5, love.graphics.getHeight()-110, 400)
            love.graphics.printf("Exit", A6, love.graphics.getHeight()-50, 400)
        else
            love.graphics.printf("Begin", A1, 10, 200)
            love.graphics.printf("Settings", A2, 110, 200)
            love.graphics.printf("Exit", A3, 210, 200)
        end
    else
        love.graphics.clear()
    end
end

return Menu, Snake, Menu.gridYCount, Menu.gridXCount





