local Menu = require("Menu")
local Game = require("Game")

function love.load()
    Menu:load()
    Game:load()
end

function love.update(dt)
    Menu:update(dt)
    Game:update(dt)
end

function love.draw()
    Menu:draw()
    Game:draw()
end

function love.keypressed(key, x, y, button, istouch)
    Menu:keypressed(key, x, y, button, istouch)
    Game:keypressed(key, x, y, button, istouch)
end
